#include "forms.h"
#include "FlDnD.h"
#include "FlDnDDemo.h"
#include "FlDemo.h"

/* select data */
unsigned long test_selection(FL_OBJECT *ob, char *data)
{
   int i,k;
   char *p;
   unsigned long s;

   p = data;
   i = fl_get_browser_maxline(ob);
   if (i == 0) return 0;
   for (k=1;k<=i;k++)
   {
      if (fl_isselected_browser_line(ob,k))
      {
	 strcpy(p,fl_get_browser_line(ob,k));
	 p += strlen(p);
	 p++;
      }
   }
   s = p - data;
   return s;

}


/* event handler */

int handle_nothing(FL_OBJECT *ob, int event,
   FL_Coord mx, FL_Coord my, int key, void *xev)
{
}

int handle_drag(FL_OBJECT *ob, int event,
   FL_Coord mx, FL_Coord my, int key, void *xev)
{
   if (!ob->belowmouse) return !FL_PREEMPT;

   switch(event)
   {
      case FL_PUSH:
	 FlDndStartAction(ob,(XEvent *)xev);
	 memset(data,0,4096);
	 size = test_selection(ob,data);
	 break;

      case FL_MOUSE: /* one of the quirks of the button class */
	 if (size > 0)
	 {
	    switch (ob->u_ldata)
	    {
	       case 1:
		  FlDndSetData(fl_get_choice(fd_screen->ch1l)-1,data,size);
		  break;

	       case 2:
		  FlDndSetData(fl_get_choice(fd_screen->ch1r)-1,data,size);
		  break;
	    }
	    if (FlDndHandleDragging(ob,(XEvent *)xev)) size = 0;
	 }
	 break;

   }
   return !FL_PREEMPT;

}


int handle_drop(FL_OBJECT *ob, int event,
   FL_Coord mx, FL_Coord my, int key, void *xev)
{
   unsigned char *string;
   char *line;
   unsigned long string_len;

   if (!ob->belowmouse) return !FL_PREEMPT;

   switch(event)
   {
      case FL_OTHER:
	 if (FlDndDataType((XEvent *)xev) == DndNotDnd) return !FL_PREEMPT;
	 FlDndGetData(&string,&string_len);
	 line  = string;
	 while (line[0] != '\0')
	 {
	    fl_add_browser_line(ob,line);
	    line = line + strlen(line) + 1;
	 }
	 return FL_PREEMPT;

   }
   return !FL_PREEMPT;

}


int handle_dnd(FL_OBJECT *ob, int event,
   FL_Coord mx, FL_Coord my, int key, void *xev)
{
   int i;
   unsigned char *string;
   char *line;
   unsigned long string_len;

   if (!ob->belowmouse) return !FL_PREEMPT;

   switch(event)
   {
      case FL_OTHER:
	 if (FlDndDataType((XEvent *)xev) == DndNotDnd) return !FL_PREEMPT;
	 FlDndGetData(&string,&string_len);
	 line  = string;
	 while (line[0] != '\0')
	 {
	    fl_add_browser_line(ob,line);
	    line = line + strlen(line) + 1;
	 }
	 return FL_PREEMPT;

      case FL_PUSH:
	 FlDndStartAction(ob,(XEvent *)xev);
	 memset(data,0,4096);
	 size  = test_selection(ob,data);
	 break;

      case FL_MOUSE: /* one of the quirks of the button class */
	 if (size > 0)
	 {
	    switch (ob->u_ldata)
	    {
	       case 1:
		  FlDndSetData(fl_get_choice(fd_screen->ch1l)-1,data,size);
		  break;

	       case 2:
		  FlDndSetData(fl_get_choice(fd_screen->ch1r)-1,data,size);
		  break;
	    }
	    if (FlDndHandleDragging(ob,(XEvent *)xev)) size = 0;
	 }
	 break;

   }
   return !FL_PREEMPT;

}


/* callbacks for form screen */
void none_cb(FL_OBJECT *ob, long data)
{
/* fill-in code for callback */
}

void ch1_cb(FL_OBJECT *ob, long data)
{
/* fill-in code for callback */
}

void ch2_cb(FL_OBJECT *ob, long data)
{
/* set the behavior */
   int i;

   i = fl_get_choice(ob);

   switch (i)
   {
      case 1:
	 if (data == 1) fl_set_object_posthandler(fd_screen->brl,handle_nothing);
	 if (data == 2) fl_set_object_posthandler(fd_screen->brr,handle_nothing);
	 break;

      case 2:
	 if (data == 1) fl_set_object_posthandler(fd_screen->brl,handle_drag);
	 if (data == 2) fl_set_object_posthandler(fd_screen->brr,handle_drag);
	 break;

      case 3:
	 if (data == 1) fl_set_object_posthandler(fd_screen->brl,handle_drop);
	 if (data == 2) fl_set_object_posthandler(fd_screen->brr,handle_drop);
	 break;

      case 4:
	 if (data == 1) fl_set_object_posthandler(fd_screen->brl,handle_dnd);
	 if (data == 2) fl_set_object_posthandler(fd_screen->brr,handle_dnd);
	 break;
   }

}

void but_cb(FL_OBJECT *ob, long data)
{
/* fill-in code for callback */
   switch (data)
   {
      case 1:
	 fl_add_browser_line(fd_screen->brl,fl_show_input("Enter a string","test"));
	 break;

      case 2:
	 fl_add_browser_line(fd_screen->brr,fl_show_input("Enter a string","test"));
	 break;

      case 3:
	 fl_clear_browser(fd_screen->brl);
	 break;

      case 4:
	 fl_clear_browser(fd_screen->brr);
	 break;

   }

}

